PROGRAM MESMERIZE3(INPUT,OUTPUT);
USES(AUDVID);
USES(MATH);
CONST
	DUMMY = 0;
	PC=10;		{RESERVED FOR CARRY FLAG IN REGS[]}
    AR=11;		{RESERVED FOR .A REGISTER IN REGS[]}
    XR=12;		{RESERVED FOR .X REGISTER IN REGS[]}
    YR=13;		{RESERVED FOR .Y REGISTER IN REGS[]}
    GFX=-224;	{$ff20 kernal graph init}
    GCS=-221;	{$ff23 kernal graph clear}
    GCL=-215;	{$ff29 kernal graph set colors}
    LIN=-212;	{$ff2c kernal graph draw line}
	GXY=-16;    {$fff0 kernal PLOT}	
	GETIN=$FFE4;	{KERNAL GETIN}
	SCR=-161;		{$FF5F KERNAL SCREEN MODE}	
	BMAX=6;		{MAXIMUM NUMBER OF BOXES}
	CMAX=6;		{MAXIMUM NUMBER OF CORNERS}
	DMAX=30;	{MAXIMUM DEPTH}
	XMAX=319;
	YMAX=239;	
VAR BX,BY: ARRAY [0..2160] OF INTEGER; 
	XI,YI: ARRAY [0..36] OF INTEGER;		{BMAX * CMAX}
	B,NB: INTEGER; {CURRENT BOX, NUMBER OF BOXES}
	C,NC: INTEGER; {CURRENT CORNER, NUMBER OF CORNERS}
	BC: ARRAY [0..BMAX] OF INTEGER; {BOX COLOR}
	P1,P2,P3,P4,BD,I: INTEGER;	{COUNTERS}
	CGB,LOOP,ST: BOOLEAN; {CHANGE COLOR ON BOUNCE}
	CH: CHAR;
	OLDNCMAX,S,DWELL,NTC,SEG,NCREC,DPREC: INTEGER;

PROCEDURE GRAPHICS;					{turn on grahics mode}
    BEGIN
        REGS[0]:=0;
        CALL(GFX);
    END;

PROCEDURE GCLEAR;					{clear graphics screen}
    BEGIN
        CALL(GCS);
    END;
	
PROCEDURE GCOLORS(FG,BG,FILL: INTEGER);	{set frame buffer colors}
    BEGIN
        REGS[AR]:=FG;
        REGS[YR]:=BG;
        REGS[XR]:=FILL;
        CALL(GCL);
    END;	

PROCEDURE LINE(X1,Y1,X2,Y2:INTEGER);	{DRAW LINE}
    BEGIN
        REGS[0]:=X1;
		REGS[1]:=Y1;
		REGS[2]:=X2;
		REGS[3]:=Y2;
        CALL(LIN);
    END;
	
PROCEDURE PAUSE(JIFFIES: INTEGER);
	BEGIN
		REGS[AR]:=JIFFIES;
		WAIT();
	END;

PROCEDURE FMNOTE(CHANNEL,NOTE: INTEGER);
VAR ADDR: INTEGER;
	BEGIN
		ADDR:=$C003;		{can't load this directly!}
		REGS[0]:=ADDR;		{$C003 BASIC FMNOTE LO BYTE}
		REGS[AR]:=CHANNEL;
		REGS[XR]:=NOTE;
		REGS[PC]:=0;		{CARRY MUST BE CLEAR}
		AUDIO();			{ACCESS BASIC AUDIO ROUTINE}
	END;

PROCEDURE INSTRUMENT(CHANNEL,PATCH: INTEGER);
VAR ADDR: INTEGER;
	BEGIN
		ADDR:=$C069;		
		REGS[0]:=ADDR;		{$C069 LOAD PATCH(INSTRUMENT)}
		REGS[AR]:=CHANNEL;
		REGS[XR]:=PATCH;
		REGS[PC]:=1;		{CARRY MUST BE SET}
		AUDIO();			{ACCESS BASIC AUDIO ROUTINE}
	END;	
	
PROCEDURE INIT(B,C: INTEGER);
VAR B1,C1,N,I,P: INTEGER;
	BEGIN
		B1:=1;	{leave this at 1!}
		P:=RAND(64);
		REPEAT
			BC[B1]:=16;
			WHILE BC[B1] = 16 DO BC[B1]:=RAND(254)+1;
			C1:=0;
			REPEAT
				N:=(B1*NC)+C1;			{XI(B,C)}
				XI[N]:=RAND(5)+1;
				IF RAND(20)+1 > 10 THEN XI[N]:=-XI[N];
				YI[N]:=RAND(5)+1;
				IF RAND(20)+1 > 10 THEN YI[N]:=-XI[N];				
				I:=(B1*180)+C1;			{BX(B,0,C)}
				BX[I]:=RAND(255)+P; 
				BY[I]:=RAND(239);
				C1:=C1+1;
			UNTIL C1 > C;
			B1:=B1+1;
		UNTIL B1 > B;		
	END;
	
PROCEDURE GOTOXY(COL,ROW: INTEGER);
	BEGIN
		REGS[PC]:=0;
		REGS[YR]:=COL;
		REGS[XR]:=ROW;
		CALL(GXY);
	END;	
	
PROCEDURE DRAW(SOUND: INTEGER);
VAR C1,I,N: INTEGER;
X1,X2,X3,Y1,Y2,Y3,S: INTEGER;
	BEGIN	
		WHILE P1 < NB DO BEGIN				{DO ALL SHAPES}
			I:= (P1*180)+(P3*NC-1)+NC-1;	{BX(P1,P3,NC)}
			X2:=BX[I];
			Y2:=BY[I];
			C1:=0;
			REPEAT
				X1:=X2;
				I:=(P1*180)+(P3*NC-1)+C1;		{BX(P1,P3,C)}	
				X2:=BX[I];
				Y1:=Y2;
				Y2:=BY[I];
				GCOLORS(16,16,16);
				LINE(X1,Y1,X2,Y2);			
				I:=(P1*180)+(P2*NC-1)+C1; 		{BX(P1,P2,C)}
				N:=(P1*NC-1)+C1;
				X3:=BX[I]+XI[N];
				Y3:=BY[I]+YI[N];
				IF X3 > XMAX THEN BEGIN
					XI[N]:=-(RAND(4)+2);
					X3:=XMAX;
				END;
				IF X3 < 0 THEN BEGIN
					XI[N]:=RAND(9)+2;
					X3:=0;
				END;
				IF X3 = XMAX THEN BEGIN {AND CGB THEN BEGIN}
					BC[P1]:=16;
					WHILE BC[P1] = 16 DO BC[P1]:=RAND(254)+1;
				END;	{END IF X3 > XMAX OR < 0 OR NEITHER}
			
				IF Y3 > YMAX THEN BEGIN
					YI[N]:=-(RAND(4)+2);
					Y3:=YMAX;
				END;
				IF Y3 < 0 THEN BEGIN
					YI[N]:=RAND(9)+2;
					Y3:=0
				END;
				IF Y3 = YMAX THEN BEGIN {AND CGB THEN BEGIN}
					S:=RAND(3)+1;
					FMNOTE(S,SOUND);			
					BC[P1]:=16;
					WHILE BC[P1] = 16 DO BC[P1]:=RAND(254)+1;
				END;	{END IF Y3}		
				I:=(P1*180)+(P3*NC-1)+C1;		{BX(P1,P3,C)}
				BX[I]:=X3;
				BY[I]:=Y3;
				C1:=C1+1;
			UNTIL C1 = NC;
			
			X2:=X3;
			Y2:=Y3;
			P4:=BC[P1];
			C1:=0;
			REPEAT
				X1:=X2;
				I:=(P1*180)+(P3*NC-1)+C1;		{BX(P1,P3,C)}
				X2:=BX[I];
				Y1:=Y2;
				Y2:=BY[I];
				GCOLORS(P4,P4,P4);
				LINE(X1,Y1,X2,Y2);
				C1:=C1+1;
			UNTIL C1 = NC;
			P1:=P1+1;
		END;	{END WHILE P1}

	END;	{END DRAW}
	
PROCEDURE DRAWNULL;
VAR C1,I,N: INTEGER;
X1,X2,X3,Y1,Y2,Y3,S: INTEGER;
	BEGIN	
		WHILE P1 < NB DO BEGIN				{DO ALL SHAPES}
			I:= (P1*180)+(P3*NC-1)+NC-1;	{BX(P1,P3,NC)}
			X2:=BX[I];
			Y2:=BY[I];
			C1:=0;
			REPEAT
				X1:=X2;
				I:=(P1*180)+(P3*NC-1)+C1;		{BX(P1,P3,C)}	
				X2:=BX[I];
				Y1:=Y2;
				Y2:=BY[I];
				GCOLORS(16,16,16);
				LINE(X1,Y1,X2,Y2);			
				I:=(P1*180)+(P2*NC-1)+C1; 		{BX(P1,P2,C)}
				N:=(P1*NC-1)+C1;
				X3:=BX[I]+XI[N];
				Y3:=BY[I]+YI[N];
				IF X3 > XMAX THEN BEGIN
					XI[N]:=-(RAND(4)+2);
					X3:=XMAX;
				END;
				IF X3 < 0 THEN BEGIN
					XI[N]:=RAND(9)+2;
					X3:=0;
				END;
				IF X3 = XMAX THEN BEGIN {AND CGB THEN BEGIN}
					BC[P1]:=16;
					WHILE BC[P1] = 16 DO BC[P1]:=RAND(254)+1;
				END;	{END IF X3 > XMAX OR < 0 OR NEITHER}
			
				IF Y3 > YMAX THEN BEGIN
					YI[N]:=-(RAND(4)+2);
					Y3:=YMAX;
				END;
				IF Y3 < 0 THEN BEGIN
					YI[N]:=RAND(9)+2;
					Y3:=0
				END;
				IF Y3 = YMAX THEN BEGIN {AND CGB THEN BEGIN}
					BC[P1]:=16;
					WHILE BC[P1] = 16 DO BC[P1]:=RAND(254)+1;
				END;	{END IF Y3}		
				I:=(P1*180)+(P3*NC-1)+C1;		{BX(P1,P3,C)}
				BX[I]:=X3;
				BY[I]:=Y3;
				C1:=C1+1;
			UNTIL C1 = NC;
			
			X2:=X3;
			Y2:=Y3;
			P4:=BC[P1];
			C1:=0;
			REPEAT
				X1:=X2;
				I:=(P1*180)+(P3*NC-1)+C1;		{BX(P1,P3,C)}
				X2:=BX[I];
				Y1:=Y2;
				Y2:=BY[I];
				GCOLORS(16,16,16);
				LINE(X1,Y1,X2,Y2);
				C1:=C1+1;
			UNTIL C1 = NC;
			P1:=P1+1;
		END;	{END WHILE P1}

	END;	{END DRAW}	
	
FUNCTION GETKEY: CHAR;
	BEGIN
		CALL(GETIN);
		GETKEY:=REGS[AR];
	END;
	
PROCEDURE SCRNMODE(MODE:INTEGER);
	BEGIN
		REGS[AR]:=MODE;
		CALL(SCR);
	END;	
	
PROCEDURE ZERO;
VAR I: INTEGER;
	BEGIN
		I:=0;
		WRITELN('PLEASE STAND BY, GATHERING STRINGS...');
		REPEAT
			BX[I]:=0;
			BY[I]:=0;
			I:=I+1;
		UNTIL I > 2159;
	END;	

	
	BEGIN	{MAIN}
		ZERO;
		CH:=CHR(147);
		WRITE(CH);		{CLEAR SCREEN}		
		OLDNCMAX:=0;
		ST:=TRUE;
		INSTRUMENT(1,99);
		LOOP:=TRUE;
		SCRNMODE(1);
		WRITELN('MESMERIZE!, VERSION 2.0');
		WRITELN('INSPIRED BY AHENRY3068s MYSTIFY CLONE');
		WRITELN;
		WRITE('AFTER STRINGS BEGIN TO DISPLAY, PRESS (C) TO CHANGE');
		WRITELN(' PARAMETERS OR QUIT.');
		PAUSE(600);
		NB:=1;
		NC:=2;
		BD:=10;
		S:=RAND(10)+35;
		INIT(NB,NC);
			WHILE LOOP = TRUE DO BEGIN	
				IF ST = FALSE THEN BEGIN
					WRITELN('NUMBER OF STRINGS TO DISPLAY - (1-2)');
					NB:=0;
					WHILE (NB = 0) OR (NB > 2) DO READ(NB);
					IF NB = 1 THEN NCREC:=4
						ELSE IF NB = 2 THEN NCREC:=3 
							ELSE IF NB = 3 THEN NCREC:= 2;			
					WRITE('NUMBER OF VERTICES PER STRING - (2-4) RECOMMEMDED MAX IS ');
					WRITELN(NCREC);
					NC:=0;
					WHILE (NC = 0) OR (NC > 4) DO READ(NC);
					SEG:=NC*NB;
					IF SEG = 2 THEN DPREC:=30
						ELSE IF SEG = 3 THEN DPREC:=15
							ELSE IF (SEG = 4) AND (NB = 1) THEN DPREC:=8
								ELSE IF (SEG = 4) AND (NB = 2) THEN DPREC:= 15
									ELSE IF SEG = 6 THEN DPREC:=8
										ELSE DPREC:=4;
					WRITE('NUMBER OF ECHOS PER STRING - (2-30) RECOMMENDED MAX IS ');
					WRITELN(DPREC);
					BD:=1;
					WHILE (BD = 1) OR (BD > 30) DO READ(BD);		
					INIT(NB,NC);
					WRITELN('SOUND? (Y/N)');
					READLN(CH);
					S:=46;
					IF (ORD(CH) = 'Y') OR (ORD(CH) = 'y') THEN S:=RAND(10)+35;			
					WRITELN('PRESS ANY KEY TO BEGIN');
					READ(CH);
				END;
				
				NTC:=BD*NC*NB;
				IF (NTC > OLDNCMAX) THEN BEGIN
				ST:=TRUE;
				DWELL:=NTC DIV 2;
				END;				
				IF (NTC > OLDNCMAX) THEN OLDNCMAX:=NTC;
				P1:=0;
				P2:=0;
				P3:=1;
				P4:=1;	
				GRAPHICS;
				GCOLORS(16,16,16);
				GCLEAR;
				CGB:=TRUE;
				CH:=CHR(147);
				WRITE(CH);		{CLEAR SCREEN}		
				IF ST = TRUE THEN BEGIN
					I:=0;
					WRITE('INITIALIZING.');
					REPEAT
						DRAWNULL;
						P1:=0;
						P2:=P3;
						P3:=P3+1;
						IF P3>BD THEN P3:=0;
						I:=I+1;
						WRITE('.');
					UNTIL I = DWELL;
					ST:=FALSE;
					CH:=CHR(147);
					WRITE(CH);		{CLEAR SCREEN}	
				END;			
				REPEAT
					DRAW(S);
					P1:=0;
					P2:=P3;
					P3:=P3+1;
					IF P3>BD THEN P3:=0;
					CH:=GETKEY;
					IF ORD(CH) = 'c' THEN LOOP:=FALSE;
				UNTIL LOOP = FALSE;
				SCRNMODE(1);
				WRITELN('PRESS Q TO QUIT, ANY OTHER KEY TO CONTINUE.');
				READ(CH);
				IF ORD(CH) = 'q' THEN LOOP:=FALSE ELSE LOOP:=TRUE;
			END;
	END. {MAIN}

